#! /bin/bash
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:~/bin
export PATH
#ConfFile
iptablesconf='/root/iptables.config.sh'

function rootness(){
    if [[ $EUID -ne 0 ]]; then
       echo "Error:This script must be run as root!"
       exit 1
    fi
}

function conf_list(){
    cat $iptablesconf
}

function conf_add(){
	if [ ! -f $iptablesconf ];then
        echo "Conf Not Found!"
        exit 1
	fi
    echo "Please enter vm ip:"
    read -p "(Default: Exit):" confvmip
    [ -z "$confvmip" ] && exit 1
    echo
    echo "Vmip = $confvmip"
    echo
    while true
    do
    echo "Please enter VmPort:"
    read -p "(Default: 22):" confvmport
    [ -z "$confvmport" ] && confvmport="22"
    expr $confvmport + 0 &>/dev/null
    if [ $? -eq 0 ]; then
        if [ $confvmport -ge 1 ] && [ $confvmport -le 65535 ]; then
            echo
            echo "VmPort = $confvmport"
            echo
            break
        else
            echo "Input error, please enter the number between 1-65535!"
        fi
    else
        echo "Input error, please enter the number between 1-65535!"
    fi
    done
    echo
    while true
    do
    echo "Please enter ServerPort:"
    read -p "(Default: 8899):" natconfport
    [ -z "$natconfport" ] && natconfport="8899"
    expr $natconfport + 0 &>/dev/null
    if [ $? -eq 0 ]; then
        if [ $natconfport -ge 1 ] && [ $natconfport -le 65535 ]; then
            echo
            echo "ServerPort = $natconfport"
            echo
            break
        else
            echo "Input error, please enter the number between 1-65535!"
        fi
    else
        echo "Input error, please enter the number between 1-65535!"
    fi
    done
    echo "Please enter type:"
    read -p "(tcp or udp ,Default: Exit):" conftype
    [ -z "$conftype" ] && exit 1
    echo
    echo "ConfType = $conftype"
    echo
	iptablesshell="iptables -t nat -A PREROUTING -i vmbr0 -p $conftype --dport $natconfport -j DNAT --to-destination $confvmip:$confvmport"
	if [ `grep -c "$iptablesshell" $iptablesconf` != '0' ]; then
        echo "Iptables Config Exist!"
        exit 1
    fi
    get_char(){
        SAVEDSTTY=`stty -g`
        stty -echo
        stty cbreak
        dd if=/dev/tty bs=1 count=1 2> /dev/null
        stty -raw
        stty echo
        stty $SAVEDSTTY
    }
    echo
    echo "Press Enter to continue or press Ctrl+C to exit"
    char=`get_char`
    echo $iptablesshell >> $iptablesconf
	runreturn=`$iptablesshell`
	echo $runreturn
	echo 'Config Add ok!'
}

function add_confs(){
    rootness
    conf_add
}

function del_conf(){
    echo
    while true
    do
    echo "Please enter ServerPort:"
    read -p "(Default: Exit):" confserverport
    [ -z "$confserverport" ] && exit 1
    expr $confserverport + 0 &>/dev/null
    if [ $? -eq 0 ]; then
        if [ $confserverport -ge 1 ] && [ $confserverport -le 65535 ]; then
            echo
            echo "ServrPort = $confserverport"
            echo
            break
        else
            echo "Input error, please enter the number between 1-65535!"
        fi
    else
        echo "Input error, please enter the number between 1-65535!"
    fi
    done
    echo
	iptablesshelldel=`cat $iptablesconf | grep "dport $confserverport"`
	if [ ! -n "$iptablesshelldel" ]; then
	     echo "Server Port Not found !"
		 exit 1
	fi
	iptablesshelldelshell=`echo ${iptablesshelldel//-A/-D}`
	runreturn=`$iptablesshelldelshell`
	echo $runreturn
	sed -i "/$iptablesshelldel/d" $iptablesconf
    echo 'Conf Del Ok'
}

function del_confs(){
    printf "Are you sure you want to delete Conf? This is permanent! (y/n) "
    printf "\n"
    read -p "(Default: n):" answer
    if [ -z $answer ]; then
        answer="n"
    fi
    if [ "$answer" = "y" ]; then
        rootness
		del_conf
    else
        echo "Conf Del cancelled, Nothing to do"
    fi
}

action=$1
case "$action" in
add)
    add_confs
    ;;
list)
    conf_list
    ;;
del)
    del_confs
    ;;
*)
    echo "Arguments error! [${action} ]"
    echo "Usage: `basename $0` {add|list|del}"
    ;;
esac
